// MFCStringStackDoc.cpp : CMFCStringStackDoc NX̎

#include "stdafx.h"
#include "MFCStringStack.h"
#include "MFCStringStackDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMFCStringStackDoc

IMPLEMENT_DYNCREATE(CMFCStringStackDoc, CDocument)
BEGIN_MESSAGE_MAP(CMFCStringStackDoc, CDocument)
END_MESSAGE_MAP()

// CMFCStringStackDoc RXgNV/fXgNV

CMFCStringStackDoc::CMFCStringStackDoc() {
}

CMFCStringStackDoc::~CMFCStringStackDoc() {
}

BOOL CMFCStringStackDoc::OnNewDocument() {
  if (!CDocument::OnNewDocument()) {
    return FALSE;
  }
  return TRUE;
}

// CMFCStringStackDoc VA

void CMFCStringStackDoc::Serialize(CArchive& ar) {
  if (ar.IsStoring()) {
    // TODO: i[R[hɒǉĂB
  } else {
    // TODO: ǂݍރR[hɒǉĂB
  }
}

// CMFCStringStackDoc ff

#ifdef _DEBUG
void CMFCStringStackDoc::AssertValid() const {
  CDocument::AssertValid();
}

void CMFCStringStackDoc::Dump(CDumpContext& dc) const {
  CDocument::Dump(dc);
}
#endif //_DEBUG


// CMFCStringStackDoc R}h

#ifdef USE_MFCCONTAINER
void CMFCStringStackDoc::Push(const CString& str) {
  container_.Add(str);
  UpdateAllViews(0);
}

CString CMFCStringStackDoc::Pop() {
  INT_PTR position = container_.GetCount()-1;
  CString result = container_.GetAt(position);
  container_.RemoveAt(position);
  UpdateAllViews(0);
  return result;
}

void CMFCStringStackDoc::Clear() {
  container_.RemoveAll();
  UpdateAllViews(0);
}

bool CMFCStringStackDoc::Empty() const {
  return container_.IsEmpty() == TRUE;
}

int CMFCStringStackDoc::Size() const {
  return static_cast<int>(container_.GetCount());
}

CString CMFCStringStackDoc::At(int index) const {
  return container_.GetAt(index);
}

#else /* USE_MFCCONTAINER */

void CMFCStringStackDoc::Push(const CString& str) {
  container_.push_back(str);
  UpdateAllViews(0);
}

CString CMFCStringStackDoc::Pop() {
  CString result = container_.back();
  container_.pop_back();
  UpdateAllViews(0);
  return result;
}

void CMFCStringStackDoc::Clear() {
  container_.clear();
  UpdateAllViews(0);
}

bool CMFCStringStackDoc::Empty() const {
  return container_.empty();
}

int CMFCStringStackDoc::Size() const {
  return static_cast<int>(container_.size());
}

CString CMFCStringStackDoc::At(int index) const {
  return container_.at(index);
}
#endif
